/*
Rewards API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package rewardsapi

import (
	"encoding/json"
	"time"
)

// checks if the InstantWin type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &InstantWin{}

// InstantWin struct for InstantWin
type InstantWin struct {
	Id int32 `json:"id"`
	WinResult string `json:"win_result"`
	TransactionId string `json:"transaction_id"`
	InteractionId string `json:"interaction_id"`
	ContactId string `json:"contact_id"`
	CreatedAt time.Time `json:"created_at"`
	ConfigId string `json:"config_id"`
	ChannelId string `json:"channel_id"`
	ConversationId string `json:"conversation_id"`
	PrizeName string `json:"prize_name"`
	CurrentUsage int32 `json:"current_usage"`
}

// NewInstantWin instantiates a new InstantWin object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewInstantWin(id int32, winResult string, transactionId string, interactionId string, contactId string, createdAt time.Time, configId string, channelId string, conversationId string, prizeName string, currentUsage int32) *InstantWin {
	this := InstantWin{}
	this.Id = id
	this.WinResult = winResult
	this.TransactionId = transactionId
	this.InteractionId = interactionId
	this.ContactId = contactId
	this.CreatedAt = createdAt
	this.ConfigId = configId
	this.ChannelId = channelId
	this.ConversationId = conversationId
	this.PrizeName = prizeName
	this.CurrentUsage = currentUsage
	return &this
}

// NewInstantWinWithDefaults instantiates a new InstantWin object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewInstantWinWithDefaults() *InstantWin {
	this := InstantWin{}
	return &this
}

// GetId returns the Id field value
func (o *InstantWin) GetId() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *InstantWin) GetIdOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *InstantWin) SetId(v int32) {
	o.Id = v
}

// GetWinResult returns the WinResult field value
func (o *InstantWin) GetWinResult() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.WinResult
}

// GetWinResultOk returns a tuple with the WinResult field value
// and a boolean to check if the value has been set.
func (o *InstantWin) GetWinResultOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.WinResult, true
}

// SetWinResult sets field value
func (o *InstantWin) SetWinResult(v string) {
	o.WinResult = v
}

// GetTransactionId returns the TransactionId field value
func (o *InstantWin) GetTransactionId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TransactionId
}

// GetTransactionIdOk returns a tuple with the TransactionId field value
// and a boolean to check if the value has been set.
func (o *InstantWin) GetTransactionIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TransactionId, true
}

// SetTransactionId sets field value
func (o *InstantWin) SetTransactionId(v string) {
	o.TransactionId = v
}

// GetInteractionId returns the InteractionId field value
func (o *InstantWin) GetInteractionId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.InteractionId
}

// GetInteractionIdOk returns a tuple with the InteractionId field value
// and a boolean to check if the value has been set.
func (o *InstantWin) GetInteractionIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.InteractionId, true
}

// SetInteractionId sets field value
func (o *InstantWin) SetInteractionId(v string) {
	o.InteractionId = v
}

// GetContactId returns the ContactId field value
func (o *InstantWin) GetContactId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ContactId
}

// GetContactIdOk returns a tuple with the ContactId field value
// and a boolean to check if the value has been set.
func (o *InstantWin) GetContactIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ContactId, true
}

// SetContactId sets field value
func (o *InstantWin) SetContactId(v string) {
	o.ContactId = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *InstantWin) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *InstantWin) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *InstantWin) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetConfigId returns the ConfigId field value
func (o *InstantWin) GetConfigId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConfigId
}

// GetConfigIdOk returns a tuple with the ConfigId field value
// and a boolean to check if the value has been set.
func (o *InstantWin) GetConfigIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConfigId, true
}

// SetConfigId sets field value
func (o *InstantWin) SetConfigId(v string) {
	o.ConfigId = v
}

// GetChannelId returns the ChannelId field value
func (o *InstantWin) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *InstantWin) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *InstantWin) SetChannelId(v string) {
	o.ChannelId = v
}

// GetConversationId returns the ConversationId field value
func (o *InstantWin) GetConversationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConversationId
}

// GetConversationIdOk returns a tuple with the ConversationId field value
// and a boolean to check if the value has been set.
func (o *InstantWin) GetConversationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConversationId, true
}

// SetConversationId sets field value
func (o *InstantWin) SetConversationId(v string) {
	o.ConversationId = v
}

// GetPrizeName returns the PrizeName field value
func (o *InstantWin) GetPrizeName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.PrizeName
}

// GetPrizeNameOk returns a tuple with the PrizeName field value
// and a boolean to check if the value has been set.
func (o *InstantWin) GetPrizeNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.PrizeName, true
}

// SetPrizeName sets field value
func (o *InstantWin) SetPrizeName(v string) {
	o.PrizeName = v
}

// GetCurrentUsage returns the CurrentUsage field value
func (o *InstantWin) GetCurrentUsage() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.CurrentUsage
}

// GetCurrentUsageOk returns a tuple with the CurrentUsage field value
// and a boolean to check if the value has been set.
func (o *InstantWin) GetCurrentUsageOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CurrentUsage, true
}

// SetCurrentUsage sets field value
func (o *InstantWin) SetCurrentUsage(v int32) {
	o.CurrentUsage = v
}

func (o InstantWin) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o InstantWin) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["win_result"] = o.WinResult
	toSerialize["transaction_id"] = o.TransactionId
	toSerialize["interaction_id"] = o.InteractionId
	toSerialize["contact_id"] = o.ContactId
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["config_id"] = o.ConfigId
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["conversation_id"] = o.ConversationId
	toSerialize["prize_name"] = o.PrizeName
	toSerialize["current_usage"] = o.CurrentUsage
	return toSerialize, nil
}

type NullableInstantWin struct {
	value *InstantWin
	isSet bool
}

func (v NullableInstantWin) Get() *InstantWin {
	return v.value
}

func (v *NullableInstantWin) Set(val *InstantWin) {
	v.value = val
	v.isSet = true
}

func (v NullableInstantWin) IsSet() bool {
	return v.isSet
}

func (v *NullableInstantWin) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableInstantWin(val *InstantWin) *NullableInstantWin {
	return &NullableInstantWin{value: val, isSet: true}
}

func (v NullableInstantWin) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableInstantWin) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


